/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */

export interface paths {
  "/stratifications": {
    post: {
      responses: {
        /** Stratification job started with taskId to query results */
        200: {
          content: {
            "application/json": {
              state: "PENDING" | "SUCCESS" | "FAILURE";
              taskId: string;
            };
          };
        };
      };
      /** A stratification configuration object, an area boundary, and an optional callback url. */
      requestBody: {
        content: {
          "application/json": {
            area: components["schemas"]["Area"];
            stratificationConfig: components["schemas"]["StratificationConfig"];
            callbackUrl?: string;
          };
        };
      };
    };
  };
  "/stratifications/{id}": {
    get: {
      responses: {
        /** The state of the stratification job. If the job was successful, a result is included. If the job encountered an error, an error is included. */
        200: {
          content: {
            "application/json":
              | components["schemas"]["StratificationJobSuccess"]
              | components["schemas"]["StratificationJobPending"]
              | components["schemas"]["StratificationJobFailure"];
          };
        };
      };
    };
  };
}

export interface components {
  schemas: {
    Area: {
      /** @default Feature */
      type?: "Feature";
      geometry:
        | components["schemas"]["Polygon"]
        | components["schemas"]["MultiPolygon"];
      properties?: { [key: string]: unknown };
    };
    Position: number[];
    Polygon: {
      /** @default Polygon */
      type: "Polygon";
      coordinates: components["schemas"]["Position"][][];
    };
    MultiPolygon: {
      /** @default MultiPolygon */
      type: "MultiPolygon";
      coordinates: components["schemas"]["Position"][][][];
    };
    /** StratificationConfig */
    StratificationConfig: {
      /**
       * Inputs
       * @description Input data layers used in stratification process
       */
      inputs: components["schemas"]["ConfigInput"][];
      params: components["schemas"]["ConfigParams"];
    };
    /**
     * Point
     * @description Point Model
     */
    Point: {
      /** Coordinates */
      coordinates: Partial<(Partial<number> & Partial<number>)[]> &
        Partial<(Partial<number> & Partial<number>)[]>;
      /**
       * Type
       * @default Point
       */
      type?: string;
    };
    /**
     * Feature[Point, dict]
     * @description Feature Model
     */
    Feature_Point__dict_: {
      /**
       * Type
       * @default Feature
       */
      type?: string;
      geometry?: components["schemas"]["Point"];
      /** Properties */
      properties?: { [key: string]: unknown };
      /** Id */
      id?: string;
      /** Bbox */
      bbox?: Partial<(Partial<number> & Partial<number>)[]> &
        Partial<(Partial<number> & Partial<number>)[]>;
    };
    /** Algorithm */
    Algorithm: {
      /** Name */
      name?: string;
      /** Alternatename */
      alternateName?: string;
      /** Coderepository */
      codeRepository?: string;
      /** Version */
      version?: string;
      /** Doi */
      doi?: string;
    };
    /** StratificationInput */
    StratificationInput: {
      /** Name */
      name: string;
      /** Value */
      value?: unknown;
    };
    /** Result */
    Result: {
      /** Name */
      name: string;
      /** Value */
      value?: unknown;
    };
    /** Stratification */
    Stratification: {
      /** Locations */
      locations: components["schemas"]["Feature_Point__dict_"][];
      algorithm: components["schemas"]["Algorithm"];
      /** Input */
      input: components["schemas"]["StratificationInput"][];
      /** Result */
      result: components["schemas"]["Result"][];
    };
    /**
     * InputParamsSentinel2
     * @description Parameters for Sentinel2 input data layer
     */
    InputParamsSentinel2: {
      /**
       * Dates
       * @description Date range for stratification process, specified as a string.
       */
      dates?: string;
      /**
       * Masked ratio threshold
       * @description Minimum threshold ratio of valid pixels in each raster for
       *         the raster to be included in analysis, as determined by the Sentinel-2 L2A Scene
       *         Classification Layer (SCL). Rasters are fetched and computed per date, and
       *         discarded if their ratio of pixels classified as "bad" (e.g. cloudy) pixels to
       *         "good" does not meet this value.
       */
      masked_ratio_threshold?: number;
      /**
       * NDVI Maximum
       * @description Maximum allowed NDVI value. Rasters for given dates with NDVI
       *         pixel values greater than this value will be discarded. This prevents
       *         inclusion of bad data. Valid NDVI values should not be greater than 1.0.
       */
      ndvi_max?: number;
      /**
       * Search Query
       * @description STAC catalog search query, defaults to `{"platform": {"eq": "sentinel-2a"}}`
       *         which will include only rasters from Sentinel 2A satellite. Assigning to `{}` will
       *         will include rasters from both Sentinel 2A and 2B satellites. This will result in more
       *          rasters and longer fetching times.
       */
      search_query?: {
        [key: string]: {
          [key: string]: Partial<string> & Partial<number> & Partial<number>;
        };
      };
    };
    /**
     * InputSentinel2
     * @description Sentinel2 satellite input data layer
     */
    InputSentinel2: {
      /** Source */
      source: "SENTINEL_2";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["InputParamsSentinel2"];
    };
    /** Empty */
    Empty: { [key: string]: unknown };
    /**
     * Input3DEP
     * @description 3DEP elevation input data layer
     */
    Input3DEP: {
      /** Source */
      source: "3DEP";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["Empty"];
    };
    /**
     * InputCopernicus
     * @description Copernicus input data layer
     */
    InputCopernicus: {
      /** Source */
      source: "COPERNICUS";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["Empty"];
    };
    /**
     * InputSSURGO
     * @description SSURGO soil input data layer
     */
    InputSSURGO: {
      /** Source */
      source: "SSURGO";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["Empty"];
    };
    /**
     * ConfigInput
     * @description Input data layer
     */
    ConfigInput:
      | components["schemas"]["InputSentinel2"]
      | components["schemas"]["Input3DEP"]
      | components["schemas"]["InputCopernicus"]
      | components["schemas"]["InputSSURGO"];
    /**
     * SamplingDensity
     * @description Sampling density configuration
     */
    SamplingDensity: {
      /**
       * Minimum stratum area
       * @description Lower bound for stratum area to apply this sampling density to.
       *         Specified in hectares.
       */
      min_area: number;
      /**
       * Maximum stratum area
       * @description Upper bound for stratum area to apply this sampling density to.
       *         Specified in hectares
       */
      max_area: number;
      /** Units */
      units: "HECTARES";
      /** Per */
      per: "STRATUM";
      /**
       * Sampling density
       * @description Sampling density, specified as number of samplings (locations)
       *         generated per hectare. E.g. 0.6 (locations per hectare).
       */
      density: number;
      /**
       * Minimum number of samplings
       * @description Lower bound for number of samplings generated by stratification.
       * @default 1
       */
      min_samplings?: number;
      /**
       * Maximum number of samplings
       * @description Upper bound for number of samplings generated by stratification.
       */
      max_samplings?: number;
    };
    /**
     * FieldBoundaryRasterMaskBufferDynamic
     * @description Field boundary raster mask buffer dynamic configuration
     */
    FieldBoundaryRasterMaskBufferDynamic: {
      /** Type */
      type: "DYNAMIC";
      /**
       * Buffer maximum
       * @description Lower absolute bound for field boundary buffering to remove edge
       *         effects. Specified in negative meters. E.g. -10 (m).
       */
      buffer_max: number;
      /**
       * Buffer minimum
       * @description Upper absolute bound for field boundary buffering to remove edge
       *         effects. Specified in negative meters. E.g. -30 (m).
       */
      buffer_min: number;
      /**
       * Buffer interval
       * @description Step size used to determine optimal field boundary buffering
       *         dynamically. Specified in meters. E.g. 10 (m).
       */
      buffer_interval: number;
      /**
       * Threshold
       * @description Sampleable field area threshold ratio. The underlying calculation
       *         will use the maximum buffer value within bounds (between min and max) while
       *         maintaining a sampleable area ratio greater than this value. Calculated as
       *         `sampleable_area_ratio = buffered_area / field_area`. E.g. 0.6
       */
      threshold: number;
    };
    /** FieldBoundaryRasterMaskBufferStatic */
    FieldBoundaryRasterMaskBufferStatic: {
      /** Type */
      type: "STATIC";
      /** Value */
      value: number;
    };
    /**
     * NumberOfStrataDynamicParams
     * @description Dynamic number of strata parameters
     */
    NumberOfStrataDynamicParams: (unknown | unknown) & {
      /**
       * Minimum number of strata
       * @description Lower bound for optimal strata number determination.
       */
      min: number;
      /**
       * Maximum number of strata
       * @description Upper bound for optimal strata number determination.
       */
      max: number;
      /**
       * Dynamic number of strata rate
       * @description Rate (slope) in strata per hectare for center value of optimum
       *         determination. Large values will increase stratification job processing.
       *         time. Alternatively expressed as first member of two item list in `coeffs`
       *         parameter. Either `coeffs` or `rate` and `offset` parameters are required.
       */
      rate?: number;
      /**
       * Dynamic number of strata offset
       * @description Offset (intercept) of strata per hectare for center value of
       *         optimum determination. Alternatively expressed as second member of two item list
       *         in `coeffs` parameter.  Either `coeffs` or `rate` and `offset` parameters are
       *         required.
       */
      offset?: number;
      /**
       * Dynamic number of strata polynomial coefficients
       * @description Coefficients for polynomial strata per hectare center value
       *         of optimum determination. Linear (first degree) polynomials can alternatively be
       *         expressed with `rate` and `offset` parameters. Either `coeffs` or `rate` and
       *         `offset` parameters are required.
       */
      coeffs?: number[];
      /**
       * Minimum geometry area
       * @description Lower bound for geometry area in hectares
       */
      min_area: number;
      /**
       * Maximum geometry area
       * @description Upper bound for geometry area in hectares
       */
      max_area: number;
    };
    /**
     * NumberOfStrataDynamic
     * @description Dynamic number of strata configuration
     */
    NumberOfStrataDynamic: {
      /** Type */
      type: "DYNAMIC";
      /** Value */
      value: components["schemas"]["NumberOfStrataDynamicParams"][];
      /**
       * Span
       * @description Dynamic number of strata span about center value (determined by
       *         `rate`). This value is added and subtracted from the value determined by
       *         `rate * area_ha` to determine the range of possible strata values from which to
       *         select an optimum. Note that large values will significantly increase job
       *         processing time.
       */
      span: number;
      /**
       * Padding minimum length
       * @description Minimum length that will be used for padding in determination of
       *         optimal number of strata. At least four strata values are necessary for optimal
       *         value determination. Large values will significantly increase job processing
       *         time
       */
      pad_min_length: number;
    };
    /**
     * NumberOfStrataStatic
     * @description Static number of strata configuration
     */
    NumberOfStrataStatic: {
      /** Type */
      type: "STATIC";
      /**
       * Value
       * @description Static value for number of strata used in stratification. E.g. 3
       */
      value: number;
    };
    /**
     * ConfigParams
     * @description Stratification configuration parameters
     */
    ConfigParams: {
      /** Sampling Densities */
      sampling_densities: components["schemas"]["SamplingDensity"][];
      /** Field Boundary Raster Mask Buffer */
      field_boundary_raster_mask_buffer:
        | components["schemas"]["FieldBoundaryRasterMaskBufferDynamic"]
        | components["schemas"]["FieldBoundaryRasterMaskBufferStatic"];
      /**
       * Bounding box padding (degrees WGS84)
       * @description Padding applied to bounding box around field boundary. Used
       *         when fetching input data layers for stratification.
       */
      bbox_padding_degrees?: number;
      /**
       * Random seed
       * @description Random seed used for random processes during stratification.
       */
      random_seed?: number;
      /**
       * cLHS maximum iterations
       * @description Number of iterations used in sampling location generation with"
       *         cLHS algorithm. Defaults to 1000. Larger values increase stratification job
       *         time.
       */
      clhs_max_iterations?: number;
      /** N Strata */
      n_strata:
        | components["schemas"]["NumberOfStrataDynamic"]
        | components["schemas"]["NumberOfStrataStatic"];
    };
    StratificationJobSuccess: {
      taskId: string;
      state: "SUCCESS";
      result: components["schemas"]["Stratification"];
    };
    StratificationJobPending: {
      taskId: string;
      state: "PENDING";
    };
    StratificationJobFailure: {
      taskId: string;
      state: "FAILURE";
      result: string;
      traceback: string;
    };
  };
}

export interface operations {}

export interface external {}
